#ifndef _BIP_Engine_Port_HPP_
#define _BIP_Engine_Port_HPP_

// inherited classes
#include <PortItf.hpp>

class PortValue;
class BipError;
class Connector;
class CompoundExportPort;

class Port : public virtual PortItf {
 public:
  // constructors
  Port(const string &name, const PortType &type);

  // destructor
  virtual ~Port();

  // specific
  virtual BipError &execute(PortValue &portValue) = 0;

  void addConnectedConnector(Connector &connector) { mConnectedConnectors.push_back(&connector); }
  void addConnectedPort(CompoundExportPort &port) { mConnectedPorts.push_back(&port); }
  void reset();

 protected:
  void resetConnectedConnectors();
  void resetConnectedPorts();
  const vector<Connector *> &connectedConnectors() const { return mConnectedConnectors; }
  const vector<CompoundExportPort *> &connectedPorts() const { return mConnectedPorts; }

  vector<Connector *> mConnectedConnectors;
  vector<CompoundExportPort *> mConnectedPorts;
};

#endif // _BIP_Engine_Port_HPP_
